<?php
/**
 *
 * Customized Quick links. An extension for the phpBB Forum Software package.
 *
 * @copyright (c) 2017, Galandas, http://phpbb3world.altervista.org
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace galandas\cquicklinks\acp;

/**
 * Customized Quick links ACP module.
 */
class cquick_links_module
{
	public $u_action;
	protected $action;
	protected $table;

	function main($id, $mode)
	{
		global $config, $db, $user, $template, $request, $table_prefix;
		
		$this->table = $table_prefix . 'quick_links';
		
		$this->tpl_name = 'acp_quick_links';
		$this->page_title = $user->lang('ACP_NAVBAR_MENU_TITLE');
		add_form_key('acp_quick_links');

		$sql = 'SELECT *
			FROM ' . $this->table . '
			ORDER BY quick_links_name ASC';
		$result = $db->sql_query($sql);
		while( $row = $db->sql_fetchrow($result) )
		{
			$template->assign_block_vars('quick', array(
				'L_NAME'			=> $row['quick_links_name'],
				'L_URL'				=> $row['quick_links_url'],
				'L_IMAGE'			=> $row['quick_links_image'],
				'U_EDIT'			=> $this->u_action . "&amp;id=" . $row['quick_links_id'] . "&amp;action=edit",
				'U_DELETE'			=> $this->u_action . "&amp;id=" . $row['quick_links_id'] . "&amp;action=delete"
			));
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'S_QUICK_LINKS_ENABLE'		=> $config['quick_links_enable'],
			'QUICK_LINKS_VERSION'		=> $config['quick_links_version']	
		));

		$submit = ($request->is_set_post('submit')) ? true : false;		
		$enable_submit = $request->is_set_post('enable_submit');

		$edit = ($request->is_set_post('edit')) ? true : false;		
		$edit_id = $request->variable('edit', 0);
		
		$enabled = $request->variable('enable_quick_links', 0);		
		
		if ($submit && !check_form_key('acp_quick_links') && !$edit)
		{
			trigger_error($user->lang['FORM_INVALID']);
		}
		if ($enable_submit && !check_form_key('acp_quick_links'))
		{
			trigger_error($user->lang['FORM_INVALID']);
		}
		
		if ($submit)
		{
			$name = $request->variable('name', '', true);
			$url = $request->variable('url', '');
			$image = $request->variable('image', '');

			if($name != '' && $url != '' && $image != '' && !$edit)
			{
				$sql_array = array(
					'quick_links_name'		=> $name,
					'quick_links_url'		=> $url,
					'quick_links_image'		=> $image
				);

				$sql = 'INSERT INTO ' . $this->table . ' ' . $db->sql_build_array('INSERT', $sql_array);
				$db->sql_query($sql);
				trigger_error($user->lang['NAVBAR_MENU_ADDED'] . adm_back_link($this->u_action));
			}
			else if($name != '' && $url != '' && $image != '' && isset($edit) && !empty($edit_id))
			{
				$sql_array = array(
				'quick_links_name'			=> $name,
				'quick_links_url'			=> $url,
				'quick_links_image'			=> $image
				);

				$sql = 'UPDATE ' . $this->table . ' SET ' . $db->sql_build_array('UPDATE', $sql_array) . ' WHERE quick_links_id = ' . $edit_id;
				$db->sql_query($sql);
				trigger_error($user->lang['NAVBAR_MENU_UDPATED'] . adm_back_link($this->u_action));
			}
			else
			{
				trigger_error($user->lang['NAVBAR_MENU_ERROR'] . adm_back_link($this->u_action . '&amp;action=add'), E_USER_WARNING);
			}
		}
		
		if ($enable_submit)
		{
		  set_config('quick_links_enable', $enabled);
			trigger_error($user->lang['NAVBAR_MENU_CONF_UDPATED'] . adm_back_link($this->u_action));
		}

		$action = $request->variable('action', '');
		$id_quick_links = $request->variable('id', 0);
		if($action && $id_quick_links != 0)
		{
			$action = $request->variable('action', '');
			switch ($action)
			{
				case 'edit':
					$sql = 'SELECT *
						FROM ' . $this->table . '
						WHERE quick_links_id = ' . $id_quick_links;
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$template->assign_vars(array(
						'L_NAME'			=> $row['quick_links_name'],
						'L_URL'				=> $row['quick_links_url'],
						'L_IMAGE'			=> $row['quick_links_image'],
						'L_EDIT'			=> $row['quick_links_id'],
					));
					$db->sql_freeresult($result);
				break;
				case 'delete':
					if (confirm_box(true))
					{
						$sql = 'DELETE FROM
							' . $this->table . '
							WHERE quick_links_id = ' . $id_quick_links;
						$db->sql_query($sql);
						redirect($this->u_action);
					}
					else
					{
						confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
							'action'		=> $action,
							'id'			=> $id_quick_links))
						);
					}
				break;
			}
		}
	}
}
