<?php
/**
 *
 * Customized Quick links. An extension for the phpBB Forum Software package.
 *
 * @copyright (c) 2017, Galandas, http://phpbb3world.altervista.org
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace galandas\cquicklinks\event;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
* Event listener
*/
class listener implements EventSubscriberInterface
{
	protected $db;
	protected $user;
	protected $config;
	protected $template;
	protected $table;

	public function __construct(\phpbb\db\driver\driver_interface $db, \phpbb\user $user, \phpbb\config\config $config, \phpbb\template\template $template, $quick_links)		
		
	{
		$this->db = $db;
		$this->config = $config;
		$this->template = $template;
		$this->table = $quick_links;
	}

	static public function getSubscribedEvents ()
	{
		return array(
			'core.permissions'	=> 'add_permission',
			'core.user_setup'	=> 'load_language_on_setup',		
			'core.page_header'	=> 'add_navbar_link',
		);
	}
	
	/**
	* Add permissions acp Customized Quick links
	*/
	public function add_permission($event)
	{
		$permissions = $event['permissions'];
		$permissions['a_quick_links'] = array('lang' => 'ACL_A_QUIKLINK', 'cat' => 'misc');
		$event['permissions'] = $permissions;
	}	

	/**
	* Display Customized Quick links Extension by Galandas
	*
	* @return null
	* @access public
	*/
	public function load_language_on_setup($event)
	{
		$lang_set_ext = $event['lang_set_ext'];
		$lang_set_ext[] = array(
			'ext_name' => 'galandas/cquicklinks',
			'lang_set' => 'common',
		);
		$event['lang_set_ext'] = $lang_set_ext;
	}
	
	public function add_navbar_link($event)
	{
		$sql = "SELECT * FROM " . $this->table . "
		ORDER BY quick_links_name ASC";
		$result_quick_links = $this->db->sql_query($sql);
		while( $row_quick_links = $this->db->sql_fetchrow($result_quick_links) ) 
	{
		$this->template->assign_block_vars('links', array(
		'L_NAME'		=> $row_quick_links['quick_links_name'],		
		'L_IMG'			=> $row_quick_links['quick_links_image'],
		'L_URL'			=> $row_quick_links['quick_links_url'],
		));
	}
	$this->db->sql_freeresult($result_quick_links);
	
	$this->template->assign_vars(array(
		'S_QUICK_LINKS_ENABLE'			=> (!empty($this->config['quick_links_enable'])) ? true : false,
		));		
	}	
}