<?php
/**
 *
 * Customized Quick links. An extension for the phpBB Forum Software package.
 *
 * @copyright (c) 2017, Galandas, http://phpbb3world.altervista.org
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace galandas\cquicklinks\migrations;

class install_acp_module extends \phpbb\db\migration\migration
{
	static public function depends_on()
	{
		return array('\phpbb\db\migration\data\v31x\v314');
	}

	public function update_data()
	{
		return array(
			// Add config
			array('config.add', array('quick_links_enable', 0)),
			array('config.add', array('quick_links_version', '1.0.0')),
			// Add permission
			array('permission.add', array('a_quick_links', true)),
			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_quick_links')),
			
			array('module.add', array(
				'acp',
				'ACP_CAT_DOT_MODS',
				'ACP_NAVBAR_MENU_TITLE'
			)),
			array('module.add', array(
				'acp',
				'ACP_NAVBAR_MENU_TITLE',
				array(
					'module_basename'	=> '\galandas\cquicklinks\acp\cquick_links_module',
					'modes'				=> array('settings'),
				),
			)),
		);
	}
}
